<?php

/**
 * contains all worker functions
 */
/**
 * generic form hook
 * TODO 
 * - allow selection of specific fields rather than a whole category?
 */
function _profile_setup_form($category) {
  global $user;
	$user = user_load(array('uid' => $user->uid));
	$edit = (array)$user;
	
	//skip to next step
	if ($_POST['op'] == t('Skip this')) {
		$_SESSION['profile_setup']['step']++;
		drupal_goto(_profile_setup_url($user));
	}	
	$_SESSION['profile_setup']['step'] = _category_step($category);
	
	$form = profile_form_profile($edit, $user, $category);
  $form['category'] = array('#type' => 'hidden',
	  '#value' => $category,
	);
  $form['_account'] = array('#type' => 'value',
	  '#value' => $user,
	);	
	$form['save'] = array('#type' => 'submit',
    '#value' => t('Save'),
		'#weight' => 30,
		'#prefix' => '<div class="loader"></div><div class="buttons">'
  );	
	$form['skip'] = array('#type' => 'submit',
    '#value' => t('Skip this'),
		'#weight' => 40,
		'#prefix' => ' | ',
		'#suffix' => '</div>'
  );
	return $form;
}

function __profile_setup_url($account) {
	$category = $_SESSION['profile_setup']['profile_categories'];
	
	$total_steps = count($category);
	if ($_SESSION['profile_setup']['step'] > $total_steps) {
	  //last step 
    $dest = $_SESSION['profile_setup']['destination'];
		_clean_profile_setup_sessions();
		drupal_set_message(t('Thank you for setting up your profile'));		
		module_invoke_all('profile_setup', 'complete', $account, $dest); //API 
		//workflow_ng_invoke_event('checkout_complete', $order, $user); //TODO - add workflow or rules interaction
		return !empty($dest) ? $dest : 'user';
	}
	
	//if no profile picture make that step 1
	if ($_SESSION['profile_setup']['step'] == '1') {
	  if ($account->picture == '' && variable_get('user_pictures', 0)) {
      return 'profilesetup/picture';
    }  
	  elseif ($account->picture != '') {
		  $_SESSION['profile_setup']['step']++;
	  }	
	}
	return 'profilesetup/'. $category[$_SESSION['profile_setup']['step']];
} 

/**
 * returns all the categories from the profile modules
 * Step 1 is always picture as affects logic elsewhere in module
 */
function __get_profile_categories($exclude = array(), $account = null) {
  $step = 2;
	
	//profile picture
	if (variable_get('profile_setup_user_pictures', 0) && !in_array('picture', $exclude)) {
	  if ($account) {
	    if ($account->picture == '') {
	      $categories[1] = 'picture';
	    }
	  }
	  else {
	    $categories[1] = 'picture';
	  }
	}

  //change username step
	if (variable_get('profile_setup_change_username', 0) && !in_array('username', $exclude) && user_access('change own username', $account)) {	  
		$categories[$step] = 'username';
		++$step;
	}	
	
	$result = db_query("SELECT DISTINCT(category) FROM {profile_fields} ORDER BY category");
  while ($cat = db_fetch_object($result)) {
	  //TODO - check fields in each cat are filled only show cat if empty
		if (!in_array($cat->category, $exclude)) {
		  $categories[$step] = $cat->category;
			++$step;
		}
	} 
	return $categories; 
}
